<template>
  <el-table
    :data="
      channelXAudiences.filter(
        (value) =>
          !filterName ||
          value.palomarsChannel.name
            .toLowerCase()
            .includes(filterName.toLowerCase())
      )
    "
    style="width: 100%"
    max-height="350"
  >
    <el-table-column prop="palomarsChannel.name" label="Канал">
    </el-table-column>
    <el-table-column label="Год" width="200">
      <template slot-scope="scope">
        {{ stringifyDate(scope.row.date) }}
      </template>
    </el-table-column>
    <el-table-column prop="audience.name" label="Базовая аудитория" width="200">
    </el-table-column>
    <el-table-column align="right" label="Действие">
      <template slot-scope="scope">
        <el-button
          @click.native.prevent="deleteChannelBaseAudience(scope.row)"
          type="danger"
          size="small"
        >
          Удалить
        </el-button>
      </template>
    </el-table-column>
  </el-table>
</template>

<script lang="ts">
import { Component, Mixins } from "vue-property-decorator";
import ComponentMixin from "../common/ComponentMixin";
import { AsyncRequestCatchException } from "@/decorators/AsyncExceptionCatch";
import { AxiosResponse } from "axios";
import { AxiosInstance } from "@/modules/AxiosInstance";
import {
  ChannelXAudience,
  InterfaceChannelXAudience,
} from "@/interfaces/parameters/ChannelXAudience";

/**
 * Компонент отображения базовых аудиторий.
 */
@Component
export default class TableBaseAudiencesChannelsComponent extends Mixins(
  ComponentMixin
) {
  // Коллекция каналов аудитории.
  private channelXAudiences: Array<ChannelXAudience> = [];

  private filterName = "";

  /**
   * Метод вызывается после создания компонента.
   */
  protected created(): void {
    // Подписываемся на события
    this.subscribe("reload-table", this.getTableTvr);
    this.subscribe("filter-table-name", this.getFilterName);
    this.getTableTvr();
  }

  /**
   * Метод получения названия канала для фильтрации в таблице.
   * @param text
   */
  private getFilterName(text: string): void {
    this.filterName = text;
  }

  /**
   * Метод запроса коллекций базовых аудиторий.
   */
  @AsyncRequestCatchException
  async getTableTvr(): Promise<void> {
    // Отправляем запрос
    const response: AxiosResponse = await AxiosInstance.get(
      "/channels/get-palomars-channels-x-audiences"
    );
    // Если данных нет - завершаем выполнение метода
    if (!response.data) return;
    this.channelXAudiences = (
      response.data as Array<InterfaceChannelXAudience>
    ).map((baseAudience) => new ChannelXAudience(baseAudience));
  }

  /**
   * Метод запроса удаление базовой аудитории.
   */
  @AsyncRequestCatchException
  private async deleteChannelBaseAudience(
    channel: ChannelXAudience
  ): Promise<void> {
    await AxiosInstance.post("/channels/delete", {
      palomars_channel_id: channel.palomarsChannel.id,
      audience_id: channel.audience.id,
      date: channel.date,
    });
    // Обновления таблицы базовой аудитории
    await this.getTableTvr();
  }

  /**
   *  Метод отображения даты в нормальном виде.
   * @param date
   */
  private stringifyDate(date: Date): string {
    const months = [
      "январь",
      "февраль",
      "март",
      "апрель",
      "май",
      "июнь",
      "июль",
      "август",
      "сентябрь",
      "октябрь",
      "ноябрь",
      "декабрь",
    ];
    return `${date.getFullYear()} ${months[date.getMonth()]}`;
  }
}
</script>
<style lang="scss"></style>
